HDU 1011 Starship Troopers

来源:互联网 发布:js控制台打印数据 编辑:程序博客网 时间:2024/04/30 05:20

Problem Description
You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern’s structure is like a tree in such a way that there is one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.

Input
The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively. The following N lines give the description of the rooms. Each line contains two non-negative integers – the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1’s.

Output
For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.

Sample Input
5 10
50 10
40 10
40 20
65 30
70 30
1 2
1 3
2 4
2 5
1 1
20 7
-1 -1

Sample Output
50
7

Author
XU, Chuan

Source
ZJCPC2004

解题思路:简单树形DP,但是此题有一个WA点,就是我们在状态转移的时候每棵子树上至少要派1个人,因为存在一种情况是以v为根的子树的bugs总数为0,这样如果k从0开始的话,会求解出错误的结果。

#include <cmath>#include <cstdio>#include <cstdlib>#include <cstring>#include <iostream>#include <string>#include <vector>#include <deque>#include <queue>#include <stack>#include <map>#include <set>#include <algorithm>#include <functional>using namespace std;const int maxn = 110;int n, m, u, v;struct Edge {    int v, next;    Edge() { }    Edge(int _v, int _next) : v(_v), next(_next) { }}edges[2*maxn];int head[maxn], edge_sum;void init_graph() {    edge_sum = 0;    memset(head, -1, sizeof(head));}void add_edge(int u, int v) {    edges[edge_sum].v = v;    edges[edge_sum].next = head[u];    head[u] = edge_sum++;    edges[edge_sum].v = u;    edges[edge_sum].next = head[v];    head[v] = edge_sum++;}int dp[maxn][maxn];int bugs[maxn], poss[maxn];void dfs(int u, int fa) {    for(int i = bugs[u]; i <= m; ++i) {        dp[u][i] = poss[u];    }    for(int i = head[u]; i != -1; i = edges[i].next) {        int v = edges[i].v;        if(v == fa) continue;        dfs(v, u);        for(int j = m; j >= bugs[u]; --j) {            // 注意在此处k必须从1开始枚举,因为即使以v为根的整棵子树即使没有bugs我们也至少在这棵子树上派一个人            for(int k = 1; k + bugs[u] <= j; ++k) {                if(dp[v][k] > 0) {                    dp[u][j] = max(dp[u][j], dp[u][j-k] + dp[v][k]);                }            }        }    }    return ;}int main() {    //freopen("aa.in", "r", stdin);    while(scanf("%d %d", &n, &m) != EOF) {        if(n == -1 && m == -1) break;        for(int i = 1; i <= n; ++i) {            scanf("%d %d", &bugs[i], &poss[i]);            bugs[i] = (bugs[i] / 20) + (bugs[i] % 20 > 0);        }        init_graph();        for(int i = 1; i < n; ++i) {            scanf("%d %d", &u, &v);            add_edge(u, v);        }        if(m == 0) {            printf("0\n");            continue;        }        memset(dp, 0, sizeof(dp));        dfs(1, -1);        printf("%d\n", dp[1][m]);    }    return 0;}
0 0
原创粉丝点击